icfp2014
========

Hi !
We're the "Lom Crapo" Team from France and I'm the worst of the team at coding, so I'm writing it while they finish up stuff

We chose to use OCaml with version 4.01.0 and to compile it to gcc.
You'll also need GNU Make and ocp-build.

To compile :

  opam switch 4.01.0
  eval `opam config env`
  opam install ocp-build
  ocp-build -init && make

directories:

- gcc/ contains our gcc interpreter and our compiler from ocaml to gcc

 -> make test_ocamlgcc # will run our testsuite inside our gcc-interpret

- gcc/player contains our mighty lambdaman code along with a lot of garbage

 -> make test_rococo # will run our lambda-man on our game-simulator
                     # main file is gcc/player/player_rococo.ml

- ghc/ contains our ghc code interpret, code generator and ghost code

 -> make test_ghc # should not do much

- display/creates a nice display for the game, check out for our 16 segments !

 -> make test_display

Have a nice reading, and thank you for that awesome contest.


Lambda-man Strategy
===================

At some point, we were able to run our ghc interpret in the lambda-man
program, but eventually we focus our self on a simple-but-working
strategy.

On basic mode, we look forward the nearest/biggest 'group of adjacent
pills'.

Meanwhile, we try to stay at a safe distance from ghosts. Let say 4
block away.

We to compute the UTC ir order to aim the 'fruits' before they pop
up. On simple map with dummy ghosts we eat them right after their
appearrance.

That's all.



Ghost Strategy
==============

We have two parts in our ghost strategy, the first "follower" can be seen in ghc/follower.ml
and the second "connard" (pardon my French) is in ghc/ghc_lang.ml (at the bottom).

- "follower" tries to go to the lambdaman,
  changes its decisions if going twice to the same place
- "connard" is a set of tool to make the ennemy's lambdaman crash (if it interprets it)
 -> it divides by zero, in case lambdaman forgot to check
 -> it does a MOV pc 255
 -> it creates 3 ghosts (the first and third being identical)
 -> it calls Int 2
 -> it goes to a direction above 3



OCamlGcc compiler
=================

We use an unmodifed OCaml frontend and then handle most of the language constructions, including efficient pattern-matching on ADT (and GADT...), mutable array and record, partial-application and over-application.

Our test suite, is in gcc/test/, it covers all the implemented features.

Field access on tagged block or array is in log2 of their size, see
gcc/gccBuiltins.ml for more details on the implementation.

We "branch" our gcc-generator on the OCaml 'Lambda'. Sadly, this
lambda-code does not contain any type information. We do not tried to
recompute type-information (nor to modify OCaml in order to propagate
them). Then, our list implemtation is not the most efficient one
(i.e. it do not use 'cons' for 'cons' but it ues our generic
'tagged-block' construction).

We do not handle:

- exception
- separate compilation
- some unused base types: float, string, ...
- object

