
type 'a node =
  | Nil
  | One of 'a * 'a node
  | Two of 'a node * 'a * 'a node

let rec f x =
  match x with
  | Nil -> 0
  | One (a, Nil) -> 2*a
  | One (a, Two (_, 4, (Nil | One _))) ->  3*a
  | One (a, _) when a < 0 -> -a
  | One (a, _) -> 4*a
  | Two (x, a, y) -> f x + a + 2 * f y

let g = function
  | 0 -> 0
  | 1 -> 1
  | 2 -> 2
  | 3 -> 3
  | _ -> 4

let main =
  f Nil = 0
  && f (One (2, Nil)) = 4
  && f (One (2, Two (Nil, 3, Nil) )) = 8
  && f (One (-2, Two (Nil, 3, Nil))) = 2
  && f (One (-2, Two (Nil, 4, Nil))) = -6
  && f (One (2, Two (Nil, 4, One (0, Nil)))) = 6
  && f (One (3, Two (Nil, 4, Two (Nil, 0, Nil)))) = 12
  && f (One (-3, Two (Nil, 4, Two (Nil, 0, Nil)))) = 3
  && f (Two (Nil, 1, Nil)) = 1
  && g 0 = 0
  && g 1 = 1
  && g 2 = 2
  && g 3 = 3
  && g 4 = 4
  && g 5 = 4

